"""
This list must contain all routes of the main application as (path:str, method:str, required_roles:Set[str])
"""

ALL_ROUTES_METHODS_ROLES = (
    ("/concepts/odms/forms", "GET", {"Library.Read"}),
    ("/concepts/odms/forms/headers", "GET", {"Library.Read"}),
    ("/concepts/odms/forms/{uid}", "GET", {"Library.Read"}),
    ("/concepts/odms/forms/{uid}/relationships", "GET", {"Library.Read"}),
    ("/concepts/odms/forms/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/odms/forms", "POST", {"Library.Write"}),
    ("/concepts/odms/forms/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/odms/forms/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/odms/forms/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/odms/forms/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/odms/forms/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/odms/forms/{uid}/activity-groups", "POST", {"Library.Write"}),
    ("/concepts/odms/forms/{uid}/item-groups", "POST", {"Library.Write"}),
    ("/concepts/odms/forms/{uid}/vendor-elements", "POST", {"Library.Write"}),
    ("/concepts/odms/forms/{uid}/vendor-attributes", "POST", {"Library.Write"}),
    ("/concepts/odms/forms/{uid}/vendor-element-attributes", "POST", {"Library.Write"}),
    ("/concepts/odms/forms/{uid}/vendors", "POST", {"Library.Write"}),
    ("/concepts/odms/forms/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/odms/forms/study-events", "GET", {"Library.Read"}),
    ("/concepts/odms/item-groups", "GET", {"Library.Read"}),
    ("/concepts/odms/item-groups/headers", "GET", {"Library.Read"}),
    ("/concepts/odms/item-groups/forms", "GET", {"Library.Read"}),
    ("/concepts/odms/item-groups/{uid}", "GET", {"Library.Read"}),
    ("/concepts/odms/item-groups/{uid}/relationships", "GET", {"Library.Read"}),
    ("/concepts/odms/item-groups/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/odms/item-groups", "POST", {"Library.Write"}),
    ("/concepts/odms/item-groups/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/odms/item-groups/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/odms/item-groups/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/odms/item-groups/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/odms/item-groups/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/odms/item-groups/{uid}/activity-sub-groups", "POST", {"Library.Write"}),
    ("/concepts/odms/item-groups/{uid}/items", "POST", {"Library.Write"}),
    ("/concepts/odms/item-groups/{uid}/vendor-elements", "POST", {"Library.Write"}),
    ("/concepts/odms/item-groups/{uid}/vendor-attributes", "POST", {"Library.Write"}),
    (
        "/concepts/odms/item-groups/{uid}/vendor-element-attributes",
        "POST",
        {"Library.Write"},
    ),
    ("/concepts/odms/item-groups/{uid}/vendors", "POST", {"Library.Write"}),
    ("/concepts/odms/item-groups/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/odms/items", "GET", {"Library.Read"}),
    ("/concepts/odms/items/headers", "GET", {"Library.Read"}),
    ("/concepts/odms/items/item-groups", "GET", {"Library.Read"}),
    ("/concepts/odms/items/{uid}", "GET", {"Library.Read"}),
    ("/concepts/odms/items/{uid}/relationships", "GET", {"Library.Read"}),
    ("/concepts/odms/items/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/odms/items", "POST", {"Library.Write"}),
    ("/concepts/odms/items/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/odms/items/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/odms/items/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/odms/items/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/odms/items/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/odms/items/{uid}/activities", "POST", {"Library.Write"}),
    ("/concepts/odms/items/{uid}/vendor-elements", "POST", {"Library.Write"}),
    ("/concepts/odms/items/{uid}/vendor-attributes", "POST", {"Library.Write"}),
    ("/concepts/odms/items/{uid}/vendor-element-attributes", "POST", {"Library.Write"}),
    ("/concepts/odms/items/{uid}/vendors", "POST", {"Library.Write"}),
    ("/concepts/odms/items/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/odms/conditions", "GET", {"Library.Read"}),
    ("/concepts/odms/conditions/headers", "GET", {"Library.Read"}),
    ("/concepts/odms/conditions/{uid}", "GET", {"Library.Read"}),
    ("/concepts/odms/conditions/{uid}/relationships", "GET", {"Library.Read"}),
    ("/concepts/odms/conditions/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/odms/conditions", "POST", {"Library.Write"}),
    ("/concepts/odms/conditions/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/odms/conditions/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/odms/conditions/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/odms/conditions/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/odms/conditions/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/odms/conditions/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/odms/methods", "GET", {"Library.Read"}),
    ("/concepts/odms/methods/headers", "GET", {"Library.Read"}),
    ("/concepts/odms/methods/{uid}", "GET", {"Library.Read"}),
    ("/concepts/odms/methods/{uid}/relationships", "GET", {"Library.Read"}),
    ("/concepts/odms/methods/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/odms/methods", "POST", {"Library.Write"}),
    ("/concepts/odms/methods/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/odms/methods/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/odms/methods/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/odms/methods/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/odms/methods/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/odms/methods/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/odms/formal-expressions", "GET", {"Library.Read"}),
    ("/concepts/odms/formal-expressions/headers", "GET", {"Library.Read"}),
    ("/concepts/odms/formal-expressions/{uid}", "GET", {"Library.Read"}),
    ("/concepts/odms/formal-expressions/{uid}/relationships", "GET", {"Library.Read"}),
    ("/concepts/odms/formal-expressions/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/odms/formal-expressions", "POST", {"Library.Write"}),
    ("/concepts/odms/formal-expressions/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/odms/formal-expressions/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/odms/formal-expressions/{uid}/approvals", "POST", {"Library.Write"}),
    (
        "/concepts/odms/formal-expressions/{uid}/activations",
        "DELETE",
        {"Library.Write"},
    ),
    ("/concepts/odms/formal-expressions/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/odms/formal-expressions/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/odms/descriptions", "GET", {"Library.Read"}),
    ("/concepts/odms/descriptions/headers", "GET", {"Library.Read"}),
    ("/concepts/odms/descriptions/{uid}/relationships", "GET", {"Library.Read"}),
    ("/concepts/odms/descriptions/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/odms/descriptions", "POST", {"Library.Write"}),
    ("/concepts/odms/descriptions/batch", "POST", {"Library.Write"}),
    ("/concepts/odms/descriptions/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/odms/descriptions/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/odms/descriptions/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/odms/descriptions/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/odms/descriptions/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/odms/descriptions/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/odms/aliases", "GET", {"Library.Read"}),
    ("/concepts/odms/aliases/headers", "GET", {"Library.Read"}),
    ("/concepts/odms/aliases/{uid}/relationships", "GET", {"Library.Read"}),
    ("/concepts/odms/aliases/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/odms/aliases", "POST", {"Library.Write"}),
    ("/concepts/odms/aliases/batch", "POST", {"Library.Write"}),
    ("/concepts/odms/aliases/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/odms/aliases/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/odms/aliases/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/odms/aliases/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/odms/aliases/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/odms/aliases/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/odms/vendor-namespaces", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-namespaces/headers", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-namespaces/{uid}", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-namespaces/{uid}/relationships", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-namespaces/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-namespaces", "POST", {"Library.Write"}),
    ("/concepts/odms/vendor-namespaces/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/odms/vendor-namespaces/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/odms/vendor-namespaces/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/odms/vendor-namespaces/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/odms/vendor-namespaces/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/odms/vendor-namespaces/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/odms/vendor-attributes", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-attributes/headers", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-attributes/{uid}", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-attributes/{uid}/relationships", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-attributes/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-attributes", "POST", {"Library.Write"}),
    ("/concepts/odms/vendor-attributes/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/odms/vendor-attributes/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/odms/vendor-attributes/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/odms/vendor-attributes/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/odms/vendor-attributes/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/odms/vendor-attributes/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/odms/vendor-elements", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-elements/headers", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-elements/{uid}", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-elements/{uid}/relationships", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-elements/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/odms/vendor-elements", "POST", {"Library.Write"}),
    ("/concepts/odms/vendor-elements/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/odms/vendor-elements/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/odms/vendor-elements/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/odms/vendor-elements/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/odms/vendor-elements/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/odms/vendor-elements/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/odms/metadata/xmls/export", "POST", {"Library.Write"}),
    ("/concepts/odms/metadata/csvs/export", "POST", {"Library.Write"}),
    ("/concepts/odms/metadata/xmls/import", "POST", {"Library.Write"}),
    ("/concepts/odms/metadata/xmls/stylesheets", "GET", {"Library.Read"}),
    ("/concepts/odms/metadata/xmls/stylesheets/{stylesheet}", "GET", {"Library.Read"}),
    ("/concepts/odms/study-events", "GET", {"Library.Read"}),
    ("/concepts/odms/study-events", "POST", {"Library.Write"}),
    ("/concepts/odms/study-events/headers", "GET", {"Library.Read"}),
    ("/concepts/odms/study-events/{uid}", "GET", {"Library.Read"}),
    ("/concepts/odms/study-events/{uid}/relationships", "GET", {"Library.Read"}),
    ("/concepts/odms/study-events/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/odms/study-events/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/odms/study-events/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/odms/study-events/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/odms/study-events/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/odms/study-events/{uid}/forms", "POST", {"Library.Write"}),
    ("/concepts/odms/study-events/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/odms/study-events/{uid}/versions", "POST", {"Library.Write"}),
    ("/activity-instructions", "GET", {"Library.Read"}),
    ("/activity-instructions", "POST", {"Library.Write"}),
    ("/activity-instructions/audit-trail", "GET", {"Library.Read"}),
    ("/activity-instructions/headers", "GET", {"Library.Read"}),
    ("/activity-instructions/preview", "POST", {"Library.Write"}),
    ("/activity-instructions/{uid}", "DELETE", {"Library.Write"}),
    ("/activity-instructions/{uid}", "GET", {"Library.Read"}),
    ("/activity-instructions/{uid}", "PATCH", {"Library.Write"}),
    ("/activity-instructions/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/activity-instructions/{uid}/activations", "POST", {"Library.Write"}),
    ("/activity-instructions/{uid}/approvals", "POST", {"Library.Write"}),
    ("/activity-instructions/{uid}/parameters", "GET", {"Library.Read"}),
    ("/activity-instructions/{uid}/studies", "GET", {"Study.Read"}),
    ("/activity-instructions/{uid}/versions", "GET", {"Library.Read"}),
    ("/activity-instruction-templates", "GET", {"Library.Read"}),
    ("/activity-instruction-templates/audit-trail", "GET", {"Library.Read"}),
    ("/activity-instruction-templates/headers", "GET", {"Library.Read"}),
    ("/activity-instruction-templates/{uid}", "GET", {"Library.Read"}),
    ("/activity-instruction-templates/{uid}/versions", "GET", {"Library.Read"}),
    (
        "/activity-instruction-templates/{uid}/versions/{version}",
        "GET",
        {"Library.Read"},
    ),
    ("/activity-instruction-templates/{uid}/releases", "GET", {"Library.Read"}),
    ("/activity-instruction-templates", "POST", {"Library.Write", "Study.Write"}),
    ("/activity-instruction-templates/{uid}", "PATCH", {"Library.Write"}),
    ("/activity-instruction-templates/{uid}/indexings", "PATCH", {"Library.Write"}),
    (
        "/activity-instruction-templates/{uid}/default-parameter-terms",
        "PATCH",
        {"Library.Write"},
    ),
    ("/activity-instruction-templates/{uid}/versions", "POST", {"Library.Write"}),
    (
        "/activity-instruction-templates/{uid}/approvals",
        "POST",
        {"Library.Write", "Study.Write"},
    ),
    ("/activity-instruction-templates/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/activity-instruction-templates/{uid}/activations", "POST", {"Library.Write"}),
    ("/activity-instruction-templates/{uid}", "DELETE", {"Library.Write"}),
    ("/activity-instruction-templates/{uid}/parameters", "GET", {"Library.Read"}),
    ("/activity-instruction-templates/pre-validate", "POST", {"Library.Write"}),
    ("/activity-instruction-templates/{uid}/pre-instances", "POST", {"Library.Write"}),
    ("/activity-instruction-pre-instances", "GET", {"Library.Read"}),
    ("/activity-instruction-pre-instances/headers", "GET", {"Library.Read"}),
    ("/activity-instruction-pre-instances/{uid}", "GET", {"Library.Read"}),
    ("/activity-instruction-pre-instances/{uid}", "PATCH", {"Library.Write"}),
    ("/activity-instruction-pre-instances/{uid}/indexings", "PATCH", {"Library.Write"}),
    ("/activity-instruction-pre-instances/{uid}/versions", "GET", {"Library.Read"}),
    ("/activity-instruction-pre-instances/{uid}/versions", "POST", {"Library.Write"}),
    (
        "/activity-instruction-pre-instances/{uid}/activations",
        "DELETE",
        {"Library.Write"},
    ),
    (
        "/activity-instruction-pre-instances/{uid}/activations",
        "POST",
        {"Library.Write"},
    ),
    ("/activity-instruction-pre-instances/{uid}", "DELETE", {"Library.Write"}),
    ("/activity-instruction-pre-instances/{uid}/approvals", "POST", {"Library.Write"}),
    ("/activity-instruction-pre-instances/audit-trail", "GET", {"Library.Read"}),
    ("/criteria-templates", "GET", {"Library.Read"}),
    ("/criteria-templates/audit-trail", "GET", {"Library.Read"}),
    ("/criteria-templates/headers", "GET", {"Library.Read"}),
    ("/criteria-templates/{uid}", "GET", {"Library.Read"}),
    ("/criteria-templates/{uid}/versions", "GET", {"Library.Read"}),
    ("/criteria-templates/{uid}/versions/{version}", "GET", {"Library.Read"}),
    ("/criteria-templates/{uid}/releases", "GET", {"Library.Read"}),
    ("/criteria-templates", "POST", {"Library.Write", "Study.Write"}),
    ("/criteria-templates/{uid}", "PATCH", {"Library.Write"}),
    ("/criteria-templates/{uid}/indexings", "PATCH", {"Library.Write"}),
    ("/criteria-templates/{uid}/default-parameter-terms", "PATCH", {"Library.Write"}),
    ("/criteria-templates/{uid}/versions", "POST", {"Library.Write"}),
    ("/criteria-templates/{uid}/approvals", "POST", {"Library.Write", "Study.Write"}),
    ("/criteria-templates/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/criteria-templates/{uid}/activations", "POST", {"Library.Write"}),
    ("/criteria-templates/{uid}", "DELETE", {"Library.Write"}),
    ("/criteria-templates/{uid}/parameters", "GET", {"Library.Read"}),
    ("/criteria-templates/pre-validate", "POST", {"Library.Write"}),
    ("/criteria-templates/{uid}/pre-instances", "POST", {"Library.Write"}),
    ("/criteria-pre-instances", "GET", {"Library.Read"}),
    ("/criteria-pre-instances/audit-trail", "GET", {"Library.Read"}),
    ("/criteria-pre-instances/headers", "GET", {"Library.Read"}),
    ("/criteria-pre-instances/{uid}", "GET", {"Library.Read"}),
    ("/criteria-pre-instances/{uid}", "PATCH", {"Library.Write"}),
    ("/criteria-pre-instances/{uid}/indexings", "PATCH", {"Library.Write"}),
    ("/criteria-pre-instances/{uid}/versions", "GET", {"Library.Read"}),
    ("/criteria-pre-instances/{uid}/versions", "POST", {"Library.Write"}),
    ("/criteria-pre-instances/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/criteria-pre-instances/{uid}/activations", "POST", {"Library.Write"}),
    ("/criteria-pre-instances/{uid}", "DELETE", {"Library.Write"}),
    ("/criteria-pre-instances/{uid}/approvals", "POST", {"Library.Write"}),
    ("/criteria", "GET", {"Library.Read"}),
    ("/criteria/headers", "GET", {"Library.Read"}),
    ("/criteria/{uid}", "GET", {"Library.Read"}),
    ("/criteria/{uid}/versions", "GET", {"Library.Read"}),
    ("/criteria", "POST", {"Library.Write"}),
    ("/criteria/preview", "POST", {"Library.Write"}),
    ("/criteria/{uid}", "PATCH", {"Library.Write"}),
    ("/criteria/{uid}/approvals", "POST", {"Library.Write"}),
    ("/criteria/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/criteria/{uid}/activations", "POST", {"Library.Write"}),
    ("/criteria/{uid}", "DELETE", {"Library.Write"}),
    ("/criteria/{uid}/studies", "GET", {"Study.Read"}),
    ("/criteria/{uid}/parameters", "GET", {"Library.Read"}),
    ("/objective-templates", "GET", {"Library.Read"}),
    ("/objective-templates/headers", "GET", {"Library.Read"}),
    ("/objective-templates/audit-trail", "GET", {"Library.Read"}),
    ("/objective-templates/{uid}", "GET", {"Library.Read"}),
    ("/objective-templates/{uid}/versions", "GET", {"Library.Read"}),
    ("/objective-templates/{uid}/versions/{version}", "GET", {"Library.Read"}),
    ("/objective-templates/{uid}/releases", "GET", {"Library.Read"}),
    ("/objective-templates", "POST", {"Library.Write", "Study.Write"}),
    ("/objective-templates/{uid}", "PATCH", {"Library.Write"}),
    ("/objective-templates/{uid}/indexings", "PATCH", {"Library.Write"}),
    ("/objective-templates/{uid}/default-parameter-terms", "PATCH", {"Library.Write"}),
    ("/objective-templates/{uid}/versions", "POST", {"Library.Write"}),
    ("/objective-templates/{uid}/approvals", "POST", {"Library.Write", "Study.Write"}),
    ("/objective-templates/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/objective-templates/{uid}/activations", "POST", {"Library.Write"}),
    ("/objective-templates/{uid}", "DELETE", {"Library.Write"}),
    ("/objective-templates/{uid}/parameters", "GET", {"Library.Read"}),
    ("/objective-templates/pre-validate", "POST", {"Library.Write"}),
    ("/objective-templates/{uid}/pre-instances", "POST", {"Library.Write"}),
    ("/objective-pre-instances", "GET", {"Library.Read"}),
    ("/objective-pre-instances/audit-trail", "GET", {"Library.Read"}),
    ("/objective-pre-instances/headers", "GET", {"Library.Read"}),
    ("/objective-pre-instances/{uid}", "GET", {"Library.Read"}),
    ("/objective-pre-instances/{uid}", "PATCH", {"Library.Write"}),
    ("/objective-pre-instances/{uid}/indexings", "PATCH", {"Library.Write"}),
    ("/objective-pre-instances/{uid}/versions", "GET", {"Library.Read"}),
    ("/objective-pre-instances/{uid}/versions", "POST", {"Library.Write"}),
    ("/objective-pre-instances/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/objective-pre-instances/{uid}/activations", "POST", {"Library.Write"}),
    ("/objective-pre-instances/{uid}", "DELETE", {"Library.Write"}),
    ("/objective-pre-instances/{uid}/approvals", "POST", {"Library.Write"}),
    ("/objectives", "GET", {"Library.Read"}),
    ("/objectives/audit-trail", "GET", {"Library.Read"}),
    ("/objectives/headers", "GET", {"Library.Read"}),
    ("/objectives/{uid}", "GET", {"Library.Read"}),
    ("/objectives/{uid}/versions", "GET", {"Library.Read"}),
    ("/objectives/{uid}/studies", "GET", {"Study.Read"}),
    ("/objectives", "POST", {"Library.Write", "Study.Write"}),
    ("/objectives/preview", "POST", {"Library.Write"}),
    ("/objectives/{uid}", "PATCH", {"Library.Write"}),
    ("/objectives/{uid}/approvals", "POST", {"Library.Write", "Study.Write"}),
    ("/objectives/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/objectives/{uid}/activations", "POST", {"Library.Write"}),
    ("/objectives/{uid}", "DELETE", {"Library.Write"}),
    ("/objectives/{uid}/parameters", "GET", {"Library.Read"}),
    ("/endpoint-templates", "GET", {"Library.Read"}),
    ("/endpoint-templates/audit-trail", "GET", {"Library.Read"}),
    ("/endpoint-templates/headers", "GET", {"Library.Read"}),
    ("/endpoint-templates/{uid}", "GET", {"Library.Read"}),
    ("/endpoint-templates/{uid}/versions", "GET", {"Library.Read"}),
    ("/endpoint-templates/{uid}/versions/{version}", "GET", {"Library.Read"}),
    ("/endpoint-templates/{uid}/releases", "GET", {"Library.Read"}),
    ("/endpoint-templates", "POST", {"Library.Write", "Study.Write"}),
    ("/endpoint-templates/{uid}", "PATCH", {"Library.Write"}),
    ("/endpoint-templates/{uid}/indexings", "PATCH", {"Library.Write"}),
    ("/endpoint-templates/{uid}/default-parameter-terms", "PATCH", {"Library.Write"}),
    ("/endpoint-templates/{uid}/versions", "POST", {"Library.Write"}),
    ("/endpoint-templates/{uid}/approvals", "POST", {"Library.Write", "Study.Write"}),
    ("/endpoint-templates/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/endpoint-templates/{uid}/activations", "POST", {"Library.Write"}),
    ("/endpoint-templates/{uid}", "DELETE", {"Library.Write"}),
    ("/endpoint-templates/{uid}/parameters", "GET", {"Library.Read"}),
    ("/endpoint-templates/pre-validate", "POST", {"Library.Write"}),
    ("/endpoint-templates/{uid}/pre-instances", "POST", {"Library.Write"}),
    ("/endpoint-pre-instances", "GET", {"Library.Read"}),
    ("/endpoint-pre-instances/audit-trail", "GET", {"Library.Read"}),
    ("/endpoint-pre-instances/headers", "GET", {"Library.Read"}),
    ("/endpoint-pre-instances/{uid}", "GET", {"Library.Read"}),
    ("/endpoint-pre-instances/{uid}", "PATCH", {"Library.Write"}),
    ("/endpoint-pre-instances/{uid}/indexings", "PATCH", {"Library.Write"}),
    ("/endpoint-pre-instances/{uid}/versions", "GET", {"Library.Read"}),
    ("/endpoint-pre-instances/{uid}/versions", "POST", {"Library.Write"}),
    ("/endpoint-pre-instances/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/endpoint-pre-instances/{uid}/activations", "POST", {"Library.Write"}),
    ("/endpoint-pre-instances/{uid}", "DELETE", {"Library.Write"}),
    ("/endpoint-pre-instances/{uid}/approvals", "POST", {"Library.Write"}),
    ("/endpoints", "GET", {"Library.Read"}),
    ("/endpoints/audit-trail", "GET", {"Library.Read"}),
    ("/endpoints/headers", "GET", {"Library.Read"}),
    ("/endpoints/{uid}", "GET", {"Library.Read"}),
    ("/endpoints/{uid}/versions", "GET", {"Library.Read"}),
    ("/endpoints/{uid}/studies", "GET", {"Study.Read"}),
    ("/endpoints", "POST", {"Library.Write", "Study.Write"}),
    ("/endpoints/preview", "POST", {"Library.Write"}),
    ("/endpoints/{uid}", "PATCH", {"Library.Write"}),
    ("/endpoints/{uid}/approvals", "POST", {"Library.Write", "Study.Write"}),
    ("/endpoints/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/endpoints/{uid}/activations", "POST", {"Library.Write"}),
    ("/endpoints/{uid}", "DELETE", {"Library.Write"}),
    ("/endpoints/{uid}/parameters", "GET", {"Library.Read"}),
    ("/footnotes", "GET", {"Library.Read"}),
    ("/footnotes", "POST", {"Library.Write"}),
    ("/footnotes/audit-trail", "GET", {"Library.Read"}),
    ("/footnotes/headers", "GET", {"Library.Read"}),
    ("/footnotes/preview", "POST", {"Library.Write"}),
    ("/footnotes/{uid}", "DELETE", {"Library.Write"}),
    ("/footnotes/{uid}", "GET", {"Library.Read"}),
    ("/footnotes/{uid}", "PATCH", {"Library.Write"}),
    ("/footnotes/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/footnotes/{uid}/activations", "POST", {"Library.Write"}),
    ("/footnotes/{uid}/approvals", "POST", {"Library.Write"}),
    ("/footnotes/{uid}/parameters", "GET", {"Library.Read"}),
    ("/footnotes/{uid}/studies", "GET", {"Study.Read"}),
    ("/footnotes/{uid}/versions", "GET", {"Library.Read"}),
    ("/footnote-pre-instances", "GET", {"Library.Read"}),
    ("/footnote-pre-instances/audit-trail", "GET", {"Library.Read"}),
    ("/footnote-pre-instances/headers", "GET", {"Library.Read"}),
    ("/footnote-pre-instances/{uid}", "DELETE", {"Library.Write"}),
    ("/footnote-pre-instances/{uid}", "GET", {"Library.Read"}),
    ("/footnote-pre-instances/{uid}", "PATCH", {"Library.Write"}),
    ("/footnote-pre-instances/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/footnote-pre-instances/{uid}/activations", "POST", {"Library.Write"}),
    ("/footnote-pre-instances/{uid}/approvals", "POST", {"Library.Write"}),
    ("/footnote-pre-instances/{uid}/indexings", "PATCH", {"Library.Write"}),
    ("/footnote-pre-instances/{uid}/versions", "GET", {"Library.Read"}),
    ("/footnote-pre-instances/{uid}/versions", "POST", {"Library.Write"}),
    ("/footnote-templates", "GET", {"Library.Read"}),
    ("/footnote-templates", "POST", {"Library.Write", "Study.Write"}),
    ("/footnote-templates/audit-trail", "GET", {"Library.Read"}),
    ("/footnote-templates/headers", "GET", {"Library.Read"}),
    ("/footnote-templates/pre-validate", "POST", {"Library.Write"}),
    ("/footnote-templates/{uid}", "DELETE", {"Library.Write"}),
    ("/footnote-templates/{uid}", "GET", {"Library.Read"}),
    ("/footnote-templates/{uid}", "PATCH", {"Library.Write"}),
    ("/footnote-templates/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/footnote-templates/{uid}/activations", "POST", {"Library.Write"}),
    ("/footnote-templates/{uid}/approvals", "POST", {"Library.Write", "Study.Write"}),
    ("/footnote-templates/{uid}/default-parameter-terms", "PATCH", {"Library.Write"}),
    ("/footnote-templates/{uid}/indexings", "PATCH", {"Library.Write"}),
    ("/footnote-templates/{uid}/parameters", "GET", {"Library.Read"}),
    ("/footnote-templates/{uid}/pre-instances", "POST", {"Library.Write"}),
    ("/footnote-templates/{uid}/releases", "GET", {"Library.Read"}),
    ("/footnote-templates/{uid}/versions", "GET", {"Library.Read"}),
    ("/footnote-templates/{uid}/versions", "POST", {"Library.Write"}),
    ("/footnote-templates/{uid}/versions/{version}", "GET", {"Library.Read"}),
    ("/timeframe-templates", "GET", {"Library.Read"}),
    ("/timeframe-templates/audit-trail", "GET", {"Library.Read"}),
    ("/timeframe-templates/headers", "GET", {"Library.Read"}),
    ("/timeframe-templates/{uid}", "GET", {"Library.Read"}),
    ("/timeframe-templates/{uid}/versions", "GET", {"Library.Read"}),
    ("/timeframe-templates/{uid}/versions/{version}", "GET", {"Library.Read"}),
    ("/timeframe-templates", "POST", {"Library.Write"}),
    ("/timeframe-templates/{uid}", "PATCH", {"Library.Write"}),
    ("/timeframe-templates/{uid}/versions", "POST", {"Library.Write"}),
    ("/timeframe-templates/{uid}/approvals", "POST", {"Library.Write"}),
    ("/timeframe-templates/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/timeframe-templates/{uid}/activations", "POST", {"Library.Write"}),
    ("/timeframe-templates/{uid}", "DELETE", {"Library.Write"}),
    ("/timeframe-templates/{uid}/parameters", "GET", {"Library.Read"}),
    ("/timeframe-templates/pre-validate", "POST", {"Library.Write"}),
    ("/timeframes", "GET", {"Library.Read"}),
    ("/timeframes/audit-trail", "GET", {"Library.Read"}),
    ("/timeframes/headers", "GET", {"Library.Read"}),
    ("/timeframes/{uid}", "GET", {"Library.Read"}),
    ("/timeframes/{uid}/versions", "GET", {"Library.Read"}),
    ("/timeframes", "POST", {"Library.Write", "Study.Write"}),
    ("/timeframes/preview", "POST", {"Library.Write", "Study.Write"}),
    ("/timeframes/{uid}", "PATCH", {"Library.Write"}),
    ("/timeframes/{uid}/approvals", "POST", {"Library.Write", "Study.Write"}),
    ("/timeframes/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/timeframes/{uid}/activations", "POST", {"Library.Write"}),
    ("/timeframes/{uid}", "DELETE", {"Library.Write"}),
    ("/timeframes/{uid}/parameters", "GET", {"Library.Read"}),
    ("/libraries", "GET", {"Library.Read"}),
    ("/libraries", "POST", {"Library.Write"}),
    ("/ct/catalogues", "GET", {"Library.Read"}),
    ("/ct/catalogues/changes", "GET", {"Library.Read"}),
    ("/ct/packages", "GET", {"Library.Read"}),
    ("/ct/packages/changes", "GET", {"Library.Read"}),
    ("/ct/packages/{codelist_uid}/changes", "GET", {"Library.Read"}),
    ("/ct/packages/dates", "GET", {"Library.Read"}),
    ("/ct/codelists", "POST", {"Library.Write"}),
    ("/ct/codelists", "GET", {"Library.Read"}),
    ("/ct/codelists/{codelist_uid}/sub-codelists", "GET", {"Library.Read"}),
    ("/ct/codelists/headers", "GET", {"Library.Read"}),
    ("/ct/codelists/{codelist_uid}/terms", "POST", {"Library.Write"}),
    ("/ct/codelists/{codelist_uid}/terms/{term_uid}", "DELETE", {"Library.Write"}),
    ("/ct/codelists/attributes", "GET", {"Library.Read"}),
    ("/ct/codelists/attributes/headers", "GET", {"Library.Read"}),
    ("/ct/codelists/{codelist_uid}/attributes", "GET", {"Library.Read"}),
    ("/ct/codelists/{codelist_uid}/attributes/versions", "GET", {"Library.Read"}),
    ("/ct/codelists/{codelist_uid}/attributes", "PATCH", {"Library.Write"}),
    ("/ct/codelists/{codelist_uid}/attributes/versions", "POST", {"Library.Write"}),
    ("/ct/codelists/{codelist_uid}/attributes/approvals", "POST", {"Library.Write"}),
    ("/ct/codelists/names", "GET", {"Library.Read"}),
    ("/ct/codelists/names/headers", "GET", {"Library.Read"}),
    ("/ct/codelists/{codelist_uid}/names", "GET", {"Library.Read"}),
    ("/ct/codelists/{codelist_uid}/names/versions", "GET", {"Library.Read"}),
    ("/ct/codelists/{codelist_uid}/names", "PATCH", {"Library.Write"}),
    ("/ct/codelists/{codelist_uid}/names/versions", "POST", {"Library.Write"}),
    ("/ct/codelists/{codelist_uid}/names/approvals", "POST", {"Library.Write"}),
    ("/ct/terms", "POST", {"Library.Write"}),
    ("/ct/terms", "GET", {"Library.Read"}),
    ("/ct/terms/headers", "GET", {"Library.Read"}),
    ("/ct/terms/{term_uid}/parents", "POST", {"Library.Write"}),
    ("/ct/terms/{term_uid}/parents", "DELETE", {"Library.Write"}),
    ("/ct/terms/{term_uid}/order", "PATCH", {"Library.Write"}),
    ("/ct/terms/attributes", "GET", {"Library.Read"}),
    ("/ct/terms/attributes/headers", "GET", {"Library.Read"}),
    ("/ct/terms/{term_uid}/attributes", "GET", {"Library.Read"}),
    ("/ct/terms/{term_uid}/attributes/versions", "GET", {"Library.Read"}),
    ("/ct/terms/{term_uid}/attributes", "PATCH", {"Library.Write"}),
    ("/ct/terms/{term_uid}/attributes/versions", "POST", {"Library.Write"}),
    ("/ct/terms/{term_uid}/attributes/approvals", "POST", {"Library.Write"}),
    ("/ct/terms/{term_uid}/attributes/activations", "DELETE", {"Library.Write"}),
    ("/ct/terms/{term_uid}/attributes/activations", "POST", {"Library.Write"}),
    ("/ct/terms/{term_uid}/attributes", "DELETE", {"Library.Write"}),
    ("/ct/terms/names", "GET", {"Library.Read"}),
    ("/ct/terms/names/headers", "GET", {"Library.Read"}),
    ("/ct/terms/{term_uid}/names", "GET", {"Library.Read"}),
    ("/ct/terms/{term_uid}/names/versions", "GET", {"Library.Read"}),
    ("/ct/terms/{term_uid}/names", "PATCH", {"Library.Write"}),
    ("/ct/terms/{term_uid}/names/versions", "POST", {"Library.Write"}),
    ("/ct/terms/{term_uid}/names/approvals", "POST", {"Library.Write"}),
    ("/ct/terms/{term_uid}/names/activations", "DELETE", {"Library.Write"}),
    ("/ct/terms/{term_uid}/names/activations", "POST", {"Library.Write"}),
    ("/ct/terms/{term_uid}/names", "DELETE", {"Library.Write"}),
    ("/ct/stats", "GET", {"Library.Read"}),
    ("/dictionaries/codelists", "GET", {"Library.Read"}),
    ("/dictionaries/codelists/headers", "GET", {"Library.Read"}),
    ("/dictionaries/codelists", "POST", {"Library.Write"}),
    ("/dictionaries/codelists/{uid}", "GET", {"Library.Read"}),
    ("/dictionaries/codelists/{uid}/versions", "GET", {"Library.Read"}),
    ("/dictionaries/codelists/{uid}", "PATCH", {"Library.Write"}),
    ("/dictionaries/codelists/{uid}/versions", "POST", {"Library.Write"}),
    ("/dictionaries/codelists/{uid}/approvals", "POST", {"Library.Write"}),
    ("/dictionaries/codelists/{uid}/terms", "POST", {"Library.Write"}),
    (
        "/dictionaries/codelists/{codelist_uid}/terms/{term_uid}",
        "DELETE",
        {"Library.Write"},
    ),
    ("/dictionaries/terms", "GET", {"Library.Read"}),
    ("/dictionaries/terms/headers", "GET", {"Library.Read"}),
    ("/dictionaries/terms", "POST", {"Library.Write"}),
    ("/dictionaries/terms/{uid}", "GET", {"Library.Read"}),
    ("/dictionaries/terms/{uid}/versions", "GET", {"Library.Read"}),
    ("/dictionaries/terms/{uid}", "PATCH", {"Library.Write"}),
    ("/dictionaries/terms/{uid}/versions", "POST", {"Library.Write"}),
    ("/dictionaries/terms/{uid}/approvals", "POST", {"Library.Write"}),
    ("/dictionaries/terms/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/dictionaries/terms/{uid}/activations", "POST", {"Library.Write"}),
    ("/dictionaries/terms/{uid}", "DELETE", {"Library.Write"}),
    ("/dictionaries/substances", "POST", {"Library.Write"}),
    ("/dictionaries/substances/{uid}", "GET", {"Library.Read"}),
    ("/dictionaries/substances", "GET", {"Library.Read"}),
    ("/dictionaries/substances/{uid}", "PATCH", {"Library.Write"}),
    ("/template-parameters", "GET", {"Library.Read"}),
    ("/template-parameters/{name}/terms", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-instances", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-instances/versions", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-instances/headers", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-instances/{uid}", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-instances/{uid}/overview", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-instances/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-instances", "POST", {"Library.Write"}),
    ("/concepts/activities/activity-instances/{uid}", "PATCH", {"Library.Write"}),
    (
        "/concepts/activities/activity-instances/{uid}/versions",
        "POST",
        {"Library.Write"},
    ),
    (
        "/concepts/activities/activity-instances/{uid}/approvals",
        "POST",
        {"Library.Write"},
    ),
    (
        "/concepts/activities/activity-instances/{uid}/activations",
        "DELETE",
        {"Library.Write"},
    ),
    (
        "/concepts/activities/activity-instances/{uid}/activations",
        "POST",
        {"Library.Write"},
    ),
    ("/concepts/activities/activity-instances/{uid}", "DELETE", {"Library.Write"}),
    ("/activity-instance-classes", "GET", {"Library.Read"}),
    ("/activity-instance-classes/headers", "GET", {"Library.Read"}),
    ("/activity-instance-classes/{uid}", "GET", {"Library.Read"}),
    ("/activity-instance-classes/{uid}/versions", "GET", {"Library.Read"}),
    ("/activity-instance-classes", "POST", {"Library.Write"}),
    ("/activity-instance-classes/{uid}", "PATCH", {"Library.Write"}),
    ("/activity-instance-classes/{uid}/versions", "POST", {"Library.Write"}),
    ("/activity-instance-classes/{uid}/approvals", "POST", {"Library.Write"}),
    ("/activity-instance-classes/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/activity-instance-classes/{uid}/activations", "POST", {"Library.Write"}),
    ("/activity-instance-classes/{uid}/model-mappings", "PATCH", {"Library.Write"}),
    ("/activity-instance-classes/{uid}", "DELETE", {"Library.Write"}),
    ("/activity-item-classes", "GET", {"Library.Read"}),
    ("/activity-item-classes/headers", "GET", {"Library.Read"}),
    ("/activity-item-classes/{uid}", "GET", {"Library.Read"}),
    ("/activity-item-classes/{uid}/versions", "GET", {"Library.Read"}),
    ("/activity-item-classes", "POST", {"Library.Write"}),
    ("/activity-item-classes/{uid}", "PATCH", {"Library.Write"}),
    ("/activity-item-classes/{uid}/versions", "POST", {"Library.Write"}),
    ("/activity-item-classes/{uid}/approvals", "POST", {"Library.Write"}),
    ("/activity-item-classes/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/activity-item-classes/{uid}/activations", "POST", {"Library.Write"}),
    ("/activity-item-classes/{uid}/model-mappings", "PATCH", {"Library.Write"}),
    ("/activity-item-classes/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/compounds", "GET", {"Library.Read"}),
    ("/concepts/compounds-simple", "GET", {"Library.Read"}),
    ("/concepts/compounds/headers", "GET", {"Library.Read"}),
    ("/concepts/compounds/{uid}", "GET", {"Library.Read"}),
    ("/concepts/compounds/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/compounds", "POST", {"Library.Write"}),
    ("/concepts/compounds/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/compounds/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/compounds/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/compounds/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/compounds/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/compounds/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/compound-aliases", "GET", {"Library.Read"}),
    ("/concepts/compound-aliases/headers", "GET", {"Library.Read"}),
    ("/concepts/compound-aliases/{uid}", "GET", {"Library.Read"}),
    ("/concepts/compound-aliases/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/compound-aliases", "POST", {"Library.Write"}),
    ("/concepts/compound-aliases/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/compound-aliases/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/compound-aliases/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/compound-aliases/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/compound-aliases/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/compound-aliases/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/activities/activities", "GET", {"Library.Read"}),
    ("/concepts/activities/activities/headers", "GET", {"Library.Read"}),
    ("/concepts/activities/activities/versions", "GET", {"Library.Read"}),
    ("/concepts/activities/activities/{uid}", "GET", {"Library.Read"}),
    ("/concepts/activities/activities/{uid}/overview", "GET", {"Library.Read"}),
    ("/concepts/activities/activities/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/activities/activities", "POST", {"Library.Write", "Study.Write"}),
    ("/concepts/activities/activities/sponsor-activities", "POST", {"Library.Write"}),
    ("/concepts/activities/activities/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/activities/activities/{uid}/versions", "POST", {"Library.Write"}),
    (
        "/concepts/activities/activities/{uid}/approvals",
        "POST",
        {"Library.Write", "Study.Write"},
    ),
    ("/concepts/activities/activities/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/activities/activities/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/activities/activities/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/activities/activity-sub-groups", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-sub-groups/versions", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-sub-groups/headers", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-sub-groups/{uid}", "GET", {"Library.Read"}),
    (
        "/concepts/activities/activity-sub-groups/{uid}/versions",
        "GET",
        {"Library.Read"},
    ),
    ("/concepts/activities/activity-sub-groups", "POST", {"Library.Write"}),
    ("/concepts/activities/activity-sub-groups/{uid}", "PATCH", {"Library.Write"}),
    (
        "/concepts/activities/activity-sub-groups/{uid}/versions",
        "POST",
        {"Library.Write"},
    ),
    (
        "/concepts/activities/activity-sub-groups/{uid}/approvals",
        "POST",
        {"Library.Write"},
    ),
    (
        "/concepts/activities/activity-sub-groups/{uid}/activations",
        "DELETE",
        {"Library.Write"},
    ),
    (
        "/concepts/activities/activity-sub-groups/{uid}/activations",
        "POST",
        {"Library.Write"},
    ),
    ("/concepts/activities/activity-sub-groups/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/activities/activity-groups", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-groups/versions", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-groups/headers", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-groups/{uid}", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-groups/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/activities/activity-groups", "POST", {"Library.Write"}),
    ("/concepts/activities/activity-groups/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/activities/activity-groups/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/activities/activity-groups/{uid}/approvals", "POST", {"Library.Write"}),
    (
        "/concepts/activities/activity-groups/{uid}/activations",
        "DELETE",
        {"Library.Write"},
    ),
    (
        "/concepts/activities/activity-groups/{uid}/activations",
        "POST",
        {"Library.Write"},
    ),
    ("/concepts/activities/activity-groups/{uid}", "DELETE", {"Library.Write"}),
    ("/concepts/numeric-values", "GET", {"Library.Read"}),
    ("/concepts/numeric-values/headers", "GET", {"Library.Read"}),
    ("/concepts/numeric-values/{uid}", "GET", {"Library.Read"}),
    ("/concepts/numeric-values", "POST", {"Library.Write", "Study.Write"}),
    ("/concepts/numeric-values-with-unit", "GET", {"Library.Read"}),
    ("/concepts/numeric-values-with-unit/headers", "GET", {"Library.Read"}),
    ("/concepts/numeric-values-with-unit/{uid}", "GET", {"Library.Read"}),
    ("/concepts/numeric-values-with-unit", "POST", {"Library.Write", "Study.Write"}),
    ("/concepts/text-values", "GET", {"Library.Read"}),
    ("/concepts/text-values/headers", "GET", {"Library.Read"}),
    ("/concepts/text-values/{uid}", "GET", {"Library.Read"}),
    ("/concepts/text-values", "POST", {"Library.Write"}),
    ("/concepts/visit-names", "GET", {"Library.Read"}),
    ("/concepts/visit-names/headers", "GET", {"Library.Read"}),
    ("/concepts/visit-names/{uid}", "GET", {"Library.Read"}),
    ("/concepts/visit-names", "POST", {"Library.Write"}),
    ("/concepts/study-days", "GET", {"Library.Read"}),
    ("/concepts/study-days/headers", "GET", {"Library.Read"}),
    ("/concepts/study-days/{uid}", "GET", {"Library.Read"}),
    ("/concepts/study-days", "POST", {"Library.Write"}),
    ("/concepts/study-weeks", "GET", {"Library.Read"}),
    ("/concepts/study-weeks/headers", "GET", {"Library.Read"}),
    ("/concepts/study-weeks/{uid}", "GET", {"Library.Read"}),
    ("/concepts/study-weeks", "POST", {"Library.Write"}),
    ("/concepts/study-duration-days", "GET", {"Library.Read"}),
    ("/concepts/study-duration-days/headers", "GET", {"Library.Read"}),
    ("/concepts/study-duration-days/{uid}", "GET", {"Library.Read"}),
    ("/concepts/study-duration-days", "POST", {"Library.Write"}),
    ("/concepts/study-duration-weeks", "GET", {"Library.Read"}),
    ("/concepts/study-duration-weeks/headers", "GET", {"Library.Read"}),
    ("/concepts/study-duration-weeks/{uid}", "GET", {"Library.Read"}),
    ("/concepts/study-duration-weeks", "POST", {"Library.Write"}),
    ("/concepts/time-points", "GET", {"Library.Read"}),
    ("/concepts/time-points/headers", "GET", {"Library.Read"}),
    ("/concepts/time-points/{uid}", "GET", {"Library.Read"}),
    ("/concepts/time-points", "POST", {"Library.Write"}),
    ("/concepts/lag-times", "GET", {"Library.Read"}),
    ("/concepts/lag-times/headers", "GET", {"Library.Read"}),
    ("/concepts/lag-times/{uid}", "GET", {"Library.Read"}),
    ("/concepts/lag-times", "POST", {"Library.Write"}),
    ("/projects", "GET", {"Library.Read"}),
    ("/projects", "POST", {"Library.Write"}),
    ("/clinical-programmes", "GET", {"Library.Read"}),
    ("/clinical-programmes", "POST", {"Library.Write"}),
    ("/admin/caches", "GET", {"Admin.Read"}),
    ("/admin/caches", "DELETE", {"Admin.Write"}),
    ("/brands", "GET", {"Library.Read"}),
    ("/brands/{uid}", "GET", {"Library.Read"}),
    ("/brands", "POST", {"Library.Write"}),
    ("/brands/{uid}", "DELETE", {"Library.Write"}),
    ("/studies", "GET", {"Study.Read"}),
    ("/studies/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/locks", "POST", {"Study.Write"}),
    ("/studies/{uid}/locks", "DELETE", {"Study.Write"}),
    ("/studies/{uid}/release", "POST", {"Study.Write"}),
    ("/studies/{uid}", "DELETE", {"Study.Write"}),
    ("/studies/{uid}", "PATCH", {"Study.Write"}),
    ("/studies/{uid}", "GET", {"Study.Read"}),
    ("/studies/{uid}/snapshot-history", "GET", {"Study.Read"}),
    ("/studies/{uid}/fields-audit-trail", "GET", {"Study.Read"}),
    ("/studies", "POST", {"Study.Write"}),
    ("/studies/{uid}/protocol-title", "GET", {"Study.Read"}),
    ("/studies/{uid}/copy-component", "PATCH", {"Study.Write"}),
    ("/studies/{uid}/time-units", "GET", {"Study.Read"}),
    ("/studies/{uid}/time-units", "PATCH", {"Study.Write"}),
    ("/studies/{uid}/design.svg", "GET", {"Study.Read"}),
    ("/studies/{study_uid}/flowchart", "GET", {"Study.Read"}),
    ("/studies/{study_uid}/flowchart/coordinates", "GET", {"Study.Read"}),
    ("/studies/{study_uid}/flowchart.html", "GET", {"Study.Read"}),
    ("/studies/{study_uid}/flowchart.docx", "GET", {"Study.Read"}),
    ("/studies/{uid}/interventions", "GET", {"Study.Read"}),
    ("/studies/{uid}/interventions.html", "GET", {"Study.Read"}),
    ("/studies/{uid}/interventions.docx", "GET", {"Study.Read"}),
    ("/study-objectives", "GET", {"Study.Read"}),
    ("/study-objectives/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-objectives", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-objectives/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-objectives/audit-trail", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-objectives/{study_objective_uid}", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-objectives/{study_objective_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-objectives", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-objectives/preview", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-objectives/batch-select", "POST", {"Study.Write"}),
    (
        "/studies/{uid}/study-objectives/{study_objective_uid}",
        "DELETE",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-objectives/{study_objective_uid}/order",
        "PATCH",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-objectives/{study_objective_uid}", "PATCH", {"Study.Write"}),
    (
        "/studies/{uid}/study-objectives/{study_objective_uid}/sync-latest-version",
        "POST",
        {"Study.Write"},
    ),
    ("/study-endpoints", "GET", {"Study.Read"}),
    ("/study-endpoints/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-endpoints", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-endpoints/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-endpoints/audit-trail", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-endpoints/{study_endpoint_uid}", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-endpoints/{study_endpoint_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-endpoints", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-endpoints/preview", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-endpoints/batch-select", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-endpoints/{study_endpoint_uid}", "DELETE", {"Study.Write"}),
    (
        "/studies/{uid}/study-endpoints/{study_endpoint_uid}/order",
        "PATCH",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-endpoints/{study_endpoint_uid}", "PATCH", {"Study.Write"}),
    ("/studies/{uid}/study-objectives.docx", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-objectives.html", "GET", {"Study.Read"}),
    ("/study-compounds", "GET", {"Study.Read"}),
    ("/study-compounds/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-compounds", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-compounds/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-compounds/audit-trail", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-compounds/{study_compound_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-compounds/{study_compound_uid}", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-compounds", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-compounds/{study_compound_uid}", "DELETE", {"Study.Write"}),
    (
        "/studies/{uid}/study-compounds/{study_compound_uid}/order",
        "PATCH",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-compounds/{study_compound_uid}", "PATCH", {"Study.Write"}),
    (
        "/studies/{uid}/study-endpoints/{study_endpoint_uid}/sync-latest-endpoint-version",
        "POST",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-endpoints/{study_endpoint_uid}/sync-latest-timeframe-version",
        "POST",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-endpoints/{study_endpoint_uid}/accept-version",
        "POST",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-objectives/{study_objective_uid}/accept-version",
        "POST",
        {"Study.Write"},
    ),
    ("/study-criteria", "GET", {"Study.Read"}),
    ("/study-criteria/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-criteria", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-criteria/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-criteria/audit-trail", "GET", {"Study.Read"}),
    ("/criteria/audit-trail", "GET", {"Library.Read"}),
    ("/studies/{uid}/study-criteria/{study_criteria_uid}", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-criteria/{study_criteria_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-criteria", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-criteria/preview", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-criteria/batch-select", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-criteria/{study_criteria_uid}", "PATCH", {"Study.Write"}),
    ("/studies/{uid}/study-criteria/{study_criteria_uid}", "DELETE", {"Study.Write"}),
    (
        "/studies/{uid}/study-criteria/{study_criteria_uid}/order",
        "PATCH",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-criteria/{study_criteria_uid}/key-criteria",
        "PATCH",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-criteria/{study_criteria_uid}/sync-latest-version",
        "POST",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-criteria/{study_criteria_uid}/accept-version",
        "POST",
        {"Study.Write"},
    ),
    ("/study-activities", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-activities", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-activities/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-activities/audit-trail", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-activities/{study_activity_uid}", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-activities/{study_activity_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-activities", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-activities/{study_activity_uid}", "PATCH", {"Study.Write"}),
    (
        "/studies/{uid}/study-activities/{study_activity_uid}/activity-requests-approvals",
        "PATCH",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-activities/{study_activity_uid}", "DELETE", {"Study.Write"}),
    ("/studies/{uid}/study-activities/batch", "POST", {"Study.Write"}),
    (
        "/studies/{uid}/study-activities/{study_activity_uid}/order",
        "PATCH",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-arms", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-arms/headers", "GET", {"Study.Read"}),
    ("/study-arms", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-arms/{study_arm_uid}", "PATCH", {"Study.Write"}),
    ("/studies/{uid}/study-arms", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-arms/{study_arm_uid}/audit-trail", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-arms/audit-trail", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-arms/{study_arm_uid}", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-arms/{study_arm_uid}/order", "PATCH", {"Study.Write"}),
    ("/studies/{uid}/study-arms/{study_arm_uid}", "DELETE", {"Study.Write"}),
    ("/studies/{uid}/study-elements", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-elements", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-elements/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-elements/{study_element_uid}", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-elements/{study_element_uid}", "PATCH", {"Study.Write"}),
    (
        "/studies/{uid}/study-elements/{study_element_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-element/audit-trail", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-elements/{study_element_uid}", "DELETE", {"Study.Write"}),
    ("/study-elements/allowed-element-configs", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-elements/{study_element_uid}/order",
        "PATCH",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-branch-arms", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-branch-arms", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-branch-arms/{study_branch_arm_uid}", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-branch-arms/{study_branch_arm_uid}",
        "PATCH",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-branch-arms/{study_branch_arm_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-branch-arm/audit-trail", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-branch-arms/{study_branch_arm_uid}",
        "DELETE",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-branch-arms/{study_branch_arm_uid}/order",
        "PATCH",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-branch-arms/arm/{arm_uid}", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-cohorts", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-cohorts", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-cohorts/{study_cohort_uid}", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-cohorts/{study_cohort_uid}", "PATCH", {"Study.Write"}),
    (
        "/studies/{uid}/study-cohorts/{study_cohort_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-cohort/audit-trail", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-cohorts/{study_cohort_uid}", "DELETE", {"Study.Write"}),
    ("/studies/{uid}/study-cohorts/{study_cohort_uid}/order", "PATCH", {"Study.Write"}),
    ("/studies/{uid}/ctr/odm.xml", "GET", {"Study.Read"}),
    ("/study-activity-instructions", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-activity-instructions", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-activity-instructions/{study_activity_instruction_uid}",
        "DELETE",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-activity-instructions/batch", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-activity-schedules", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-activity-schedules", "POST", {"Study.Write"}),
    (
        "/studies/{uid}/study-activity-schedules/{study_activity_schedule_uid}",
        "DELETE",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-activity-schedules/audit-trail/", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-activity-schedules/batch", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-compound-dosings", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-compound-dosings/headers", "GET", {"Study.Read"}),
    ("/study-compound-dosings/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-compound-dosings/audit-trail", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-compound-dosings/{study_compound_dosing_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-compound-dosings", "POST", {"Study.Write"}),
    (
        "/studies/{uid}/study-compound-dosings/{study_compound_dosing_uid}",
        "DELETE",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-compound-dosings/{study_compound_dosing_uid}",
        "PATCH",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-design-cells", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-design-cells", "POST", {"Study.Write"}),
    (
        "/studies/{uid}/study-design-cells/{study_design_cell_uid}",
        "PATCH",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-design-cells/{study_design_cell_uid}",
        "DELETE",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-design-cells/audit-trail/", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-design-cells/{study_design_cell_uid}/audit-trail/",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-design-cells/batch", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-design-cells/arm/{arm_uid}", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-design-cells/branch-arm/{branch_arm_uid}",
        "GET",
        {"Study.Read"},
    ),
    (
        "/studies/{uid}/study-design-cells/study-epochs/{epoch_uid}",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-disease-milestones", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-disease-milestones/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-disease-milestones/audit-trail", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-disease-milestones/{study_disease_milestone_uid}",
        "GET",
        {"Study.Read"},
    ),
    (
        "/studies/{uid}/study-disease-milestones/{study_disease_milestone_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-disease-milestones", "POST", {"Study.Write"}),
    (
        "/studies/{uid}/study-disease-milestones/{study_disease_milestone_uid}",
        "DELETE",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-disease-milestones/{study_disease_milestone_uid}/order",
        "PATCH",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-disease-milestones/{study_disease_milestone_uid}",
        "PATCH",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-epochs", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-epochs/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-epochs/{study_epoch_uid}", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-epochs/{study_epoch_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-epoch/audit-trail", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-epochs", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-epochs/preview", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-epochs/{study_epoch_uid}", "DELETE", {"Study.Write"}),
    (
        "/studies/{uid}/study-epochs/{study_epoch_uid}/order/{new_order}",
        "PATCH",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-epochs/{study_epoch_uid}", "PATCH", {"Study.Write"}),
    ("/epochs/allowed-configs", "GET", {"Study.Read"}),
    ("/studies/{uid}/allowed-consecutive-groups", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-visits", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-visits/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-visits-references", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-visits", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-visits/preview", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-visits/allowed-visit-types", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-visits/allowed-time-references", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-visits/{study_visit_uid}", "PATCH", {"Study.Write"}),
    ("/studies/{uid}/study-visits/{study_visit_uid}", "DELETE", {"Study.Write"}),
    (
        "/studies/{uid}/study-visits/{study_visit_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-visit/audit-trail", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-visits/{study_visit_uid}", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/get-amount-of-visits-in-epoch/{study_epoch_uid}",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/global-anchor-visit", "GET", {"Study.Read"}),
    ("/studies/{uid}/anchor-visits-in-group-of-subvisits", "GET", {"Study.Read"}),
    ("/studies/{uid}/anchor-visits-for-special-visit", "GET", {"Study.Read"}),
    ("/studies/{uid}/consecutive-visit-groups", "POST", {"Study.Write"}),
    (
        "/studies/{uid}/consecutive-visit-groups/{consecutive_visit_group_name}",
        "DELETE",
        {"Study.Write"},
    ),
    ("/studies/{uid}/study-soa-footnotes", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-soa-footnotes/batch-select", "POST", {"Study.Write"}),
    (
        "/studies/{uid}/study-soa-footnotes/{study_soa_footnote_uid}",
        "PATCH",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-soa-footnotes/{study_soa_footnote_uid}",
        "DELETE",
        {"Study.Write"},
    ),
    (
        "/studies/{uid}/study-soa-footnotes/{study_soa_footnote_uid}",
        "GET",
        {"Study.Read"},
    ),
    ("/studies/{uid}/study-soa-footnotes", "GET", {"Study.Read"}),
    ("/study-soa-footnotes", "GET", {"Study.Read"}),
    ("/study-soa-footnotes/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-soa-footnotes/preview", "POST", {"Study.Write"}),
    ("/studies/{uid}/study-soa-footnotes/headers", "GET", {"Study.Read"}),
    ("/studies/{uid}/study-soa-footnote/audit-trail", "GET", {"Study.Read"}),
    (
        "/studies/{uid}/study-soa-footnotes/{study_soa_footnote_uid}/audit-trail",
        "GET",
        {"Study.Read"},
    ),
    ("/concepts/unit-definitions", "GET", {"Library.Read"}),
    ("/concepts/unit-definitions/headers", "GET", {"Library.Read"}),
    ("/concepts/unit-definitions/{uid}", "GET", {"Library.Read"}),
    ("/concepts/unit-definitions/{uid}/versions", "GET", {"Library.Read"}),
    ("/concepts/unit-definitions", "POST", {"Library.Write"}),
    ("/concepts/unit-definitions/{uid}", "PATCH", {"Library.Write"}),
    ("/concepts/unit-definitions/{uid}/versions", "POST", {"Library.Write"}),
    ("/concepts/unit-definitions/{uid}/approvals", "POST", {"Library.Write"}),
    ("/concepts/unit-definitions/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/concepts/unit-definitions/{uid}/activations", "POST", {"Library.Write"}),
    ("/concepts/unit-definitions/{uid}", "DELETE", {"Library.Write"}),
    ("/parameter-templates", "GET", {"Library.Read"}),
    ("/parameter-templates/{uid}", "GET", {"Library.Read"}),
    ("/parameter-templates/{uid}/versions", "GET", {"Library.Read"}),
    ("/parameter-templates/{uid}/versions/{version}", "GET", {"Library.Read"}),
    ("/parameter-templates", "POST", {"Library.Write"}),
    ("/parameter-templates/{uid}", "PATCH", {"Library.Write"}),
    ("/parameter-templates/{uid}/versions", "POST", {"Library.Write"}),
    ("/parameter-templates/{uid}/approvals", "POST", {"Library.Write"}),
    ("/parameter-templates/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/parameter-templates/{uid}/activations", "POST", {"Library.Write"}),
    ("/parameter-templates/{uid}", "DELETE", {"Library.Write"}),
    ("/parameter-templates/{uid}/parameters", "GET", {"Library.Read"}),
    ("/parameter-templates/pre-validate", "POST", {"Library.Write"}),
    ("/listings/metadata", "GET", {"Library.Read"}),
    ("/listings/metadata/headers", "GET", {"Library.Read"}),
    ("/listings/libraries/all/gcmd/topic-cd-def", "GET", {"Library.Read"}),
    ("/listings/libraries/all/gcmd/topic-cd-def/headers", "GET", {"Library.Read"}),
    ("/listings/libraries/all/gcmd/cdisc-ct-ver", "GET", {"Library.Read"}),
    ("/listings/libraries/all/gcmd/cdisc-ct-ver/headers", "GET", {"Library.Read"}),
    ("/listings/libraries/all/gcmd/cdisc-ct-pkg", "GET", {"Library.Read"}),
    ("/listings/libraries/all/gcmd/cdisc-ct-pkg/headers", "GET", {"Library.Read"}),
    ("/listings/libraries/all/gcmd/cdisc-ct-list", "GET", {"Library.Read"}),
    ("/listings/libraries/all/gcmd/cdisc-ct-list/headers", "GET", {"Library.Read"}),
    ("/listings/libraries/all/gcmd/cdisc-ct-val", "GET", {"Library.Read"}),
    ("/listings/libraries/all/gcmd/cdisc-ct-val/headers", "GET", {"Library.Read"}),
    ("/listings/studies/{study_uid}/sdtm/tv", "GET", {"Study.Read"}),
    ("/listings/studies/{study_uid}/sdtm/ta", "GET", {"Study.Read"}),
    ("/listings/studies/{study_uid}/sdtm/ti", "GET", {"Study.Read"}),
    ("/listings/studies/{study_uid}/sdtm/ts", "GET", {"Study.Read"}),
    ("/listings/studies/{study_uid}/sdtm/te", "GET", {"Study.Read"}),
    ("/listings/studies/{study_uid}/sdtm/tdm", "GET", {"Study.Read"}),
    ("/listings/studies/{study_uid}/adam/{adam_report}", "GET", {"Study.Read"}),
    ("/listings/studies/{study_uid}/adam/{adam_report}/headers", "GET", {"Study.Read"}),
    ("/listings/studies/{study_number}/study-metadata", "GET", {"Study.Read"}),
    ("/configurations", "GET", {"Library.Read"}),
    ("/configurations/{uid}", "GET", {"Library.Read"}),
    ("/configurations/{uid}/versions", "GET", {"Library.Read"}),
    ("/configurations", "POST", {"Library.Write"}),
    ("/configurations/{uid}", "PATCH", {"Library.Write"}),
    ("/configurations/{uid}/versions", "POST", {"Library.Write"}),
    ("/configurations/{uid}/approvals", "POST", {"Library.Write"}),
    ("/configurations/{uid}/activations", "DELETE", {"Library.Write"}),
    ("/configurations/{uid}/activations", "POST", {"Library.Write"}),
    ("/configurations/{uid}", "DELETE", {"Library.Write"}),
    ("/standards/data-models", "GET", {"Library.Read"}),
    ("/standards/data-models/headers", "GET", {"Library.Read"}),
    ("/standards/data-models/{uid}", "GET", {"Library.Read"}),
    ("/standards/data-model-igs", "GET", {"Library.Read"}),
    ("/standards/data-model-igs/headers", "GET", {"Library.Read"}),
    ("/standards/data-model-igs/{uid}", "GET", {"Library.Read"}),
    ("/standards/dataset-scenarios", "GET", {"Library.Read"}),
    ("/standards/dataset-scenarios/headers", "GET", {"Library.Read"}),
    ("/standards/dataset-scenarios/{uid}", "GET", {"Library.Read"}),
    ("/standards/dataset-classes", "GET", {"Library.Read"}),
    ("/standards/dataset-classes/headers", "GET", {"Library.Read"}),
    ("/standards/dataset-classes/{uid}", "GET", {"Library.Read"}),
    ("/standards/datasets", "GET", {"Library.Read"}),
    ("/standards/datasets/headers", "GET", {"Library.Read"}),
    ("/standards/datasets/{uid}", "GET", {"Library.Read"}),
    ("/standards/class-variables", "GET", {"Library.Read"}),
    ("/standards/class-variables/headers", "GET", {"Library.Read"}),
    ("/standards/class-variables/{uid}", "GET", {"Library.Read"}),
    ("/standards/dataset-variables", "GET", {"Library.Read"}),
    ("/standards/dataset-variables/headers", "GET", {"Library.Read"}),
    ("/standards/dataset-variables/{uid}", "GET", {"Library.Read"}),
    ("/standards/sponsor-models/models", "GET", {"Library.Read"}),
    ("/standards/sponsor-models/models/headers", "GET", {"Library.Read"}),
    ("/standards/sponsor-models/models", "POST", {"Library.Write"}),
    ("/standards/sponsor-models/dataset-classes", "GET", {"Library.Read"}),
    ("/standards/sponsor-models/dataset-classes/headers", "GET", {"Library.Read"}),
    ("/standards/sponsor-models/dataset-classes", "POST", {"Library.Write"}),
    ("/standards/sponsor-models/variable-classes", "GET", {"Library.Read"}),
    ("/standards/sponsor-models/variable-classes/headers", "GET", {"Library.Read"}),
    ("/standards/sponsor-models/variable-classes", "POST", {"Library.Write"}),
    ("/standards/sponsor-models/datasets", "GET", {"Library.Read"}),
    ("/standards/sponsor-models/datasets/headers", "GET", {"Library.Read"}),
    ("/standards/sponsor-models/datasets", "POST", {"Library.Write"}),
    ("/standards/sponsor-models/dataset-variables/headers", "GET", {"Library.Read"}),
    ("/standards/sponsor-models/dataset-variables", "GET", {"Library.Read"}),
    ("/standards/sponsor-models/dataset-variables", "POST", {"Library.Write"}),
    (
        "/comment-topics",
        "GET",
        {"Library.Write", "Study.Write", "Library.Read", "Study.Read"},
    ),
    (
        "/comment-threads",
        "GET",
        {"Library.Write", "Study.Write", "Library.Read", "Study.Read"},
    ),
    (
        "/comment-threads/{uid}",
        "GET",
        {"Library.Write", "Study.Write", "Library.Read", "Study.Read"},
    ),
    (
        "/comment-threads",
        "POST",
        {"Library.Write", "Study.Write", "Library.Read", "Study.Read"},
    ),
    (
        "/comment-threads/{uid}",
        "DELETE",
        {"Library.Write", "Study.Write", "Library.Read", "Study.Read"},
    ),
    (
        "/comment-threads/{uid}",
        "PATCH",
        {"Library.Write", "Study.Write", "Library.Read", "Study.Read"},
    ),
    (
        "/comment-threads/{thread_uid}/replies",
        "GET",
        {"Library.Write", "Study.Write", "Library.Read", "Study.Read"},
    ),
    (
        "/comment-threads/{thread_uid}/replies",
        "POST",
        {"Library.Write", "Study.Write", "Library.Read", "Study.Read"},
    ),
    (
        "/comment-threads/{thread_uid}/replies/{reply_uid}",
        "GET",
        {"Library.Write", "Study.Write", "Library.Read", "Study.Read"},
    ),
    (
        "/comment-threads/{thread_uid}/replies/{reply_uid}",
        "DELETE",
        {"Library.Write", "Study.Write", "Library.Read", "Study.Read"},
    ),
    (
        "/comment-threads/{thread_uid}/replies/{reply_uid}",
        "PATCH",
        {"Library.Write", "Study.Write", "Library.Read", "Study.Read"},
    ),
    (
        "/integrations/ms-graph/users",
        "GET",
        {"Library.Write", "Study.Write", "Library.Read", "Study.Read"},
    ),
)
